"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BufferingProvider = exports.BufferingContextReact = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importStar(require("react"));
const createBufferManager = () => {
    let blocks = [];
    let onBufferingCallback = [];
    let onResumeCallback = [];
    const addBlock = (block) => {
        blocks.push(block);
        onBufferingCallback.forEach((callback) => callback());
        return {
            unblock: () => {
                blocks = blocks.filter((b) => b !== block);
                if (blocks.length === 0) {
                    onResumeCallback.forEach((callback) => callback());
                }
            },
        };
    };
    const listenForBuffering = (callback) => {
        onBufferingCallback.push(callback);
        return {
            remove: () => {
                onBufferingCallback = onBufferingCallback.filter((c) => c !== callback);
            },
        };
    };
    const listenForResume = (callback) => {
        onResumeCallback.push(callback);
        return {
            remove: () => {
                onResumeCallback = onResumeCallback.filter((c) => c !== callback);
            },
        };
    };
    return {
        blocks,
        addBlock,
        listenForBuffering,
        listenForResume,
    };
};
exports.BufferingContextReact = react_1.default.createContext(null);
const BufferingProvider = ({ children }) => {
    const [bufferManager] = (0, react_1.useState)(() => {
        return createBufferManager();
    });
    return ((0, jsx_runtime_1.jsx)(exports.BufferingContextReact.Provider, { value: bufferManager, children: children }));
};
exports.BufferingProvider = BufferingProvider;
